=== modified file '.bzrignore'
--- .bzrignore	2008-04-22 18:25:21 +0000
+++ .bzrignore	2008-05-13 21:27:08 +0000
@@ -17,3 +17,5 @@
 cover.txt
 lint.txt
 .shelf
+development-nohup.out
+testrunner-appserver-quiet.log

=== modified file 'Makefile'
--- Makefile	2008-05-05 23:40:13 +0000
+++ Makefile	2008-05-13 21:27:08 +0000
@@ -145,6 +145,12 @@
 		 -r librarian,restricted-librarian,buildsequencer,authserver,sftp,mailman,codebrowse \
 		 -C $(CONFFILE)
 
+run_all_quickly_and_quietly:
+	LPCONFIG=${LPCONFIG} PYTHONPATH=$(TWISTEDPATH):$(Z3LIBPATH):$(PYTHONPATH) \
+		 $(PYTHON) -t $(STARTSCRIPT) \
+		 -r librarian,restricted-librarian,buildsequencer,authserver,sftp,mailman,codebrowse \
+		 -C $(CONFFILE) > ${LPCONFIG}-quiet.log 2>&1
+
 pull_branches: bzr_version_info
 	# Mirror the hosted branches in the development upload area to the
 	# mirrored area.
@@ -183,6 +189,11 @@
 	@ LPCONFIG=${LPCONFIG} ${PYTHON} \
 	    utilities/killservice.py librarian buildsequencer launchpad mailman
 
+stop_quickly_and_quietly:
+	LPCONFIG=${LPCONFIG} ${PYTHON} \
+	  utilities/killservice.py librarian buildsequencer launchpad mailman \
+	  > /dev/null 2>&1
+
 shutdown: scheduleoutage stop
 	rm -f +maintenancetime.txt
 

=== added directory 'configs/testrunner-appserver'
=== added file 'configs/testrunner-appserver/authserver-lazr.conf'
--- configs/testrunner-appserver/authserver-lazr.conf	1970-01-01 00:00:00 +0000
+++ configs/testrunner-appserver/authserver-lazr.conf	2008-05-13 21:27:08 +0000
@@ -0,0 +1,10 @@
+# A schema's sections, keys, and values are automatically inherited,
+# except for '.optional' sections. Update this config to override key
+# values. Values are strings, except for numbers that look like ints.
+# The tokens true, false, and none are treated as True, False, and None.
+
+[meta]
+extends: launchpad-lazr.conf
+
+[launchpad]
+dbuser: authserver

=== added file 'configs/testrunner-appserver/launchpad-lazr.conf'
--- configs/testrunner-appserver/launchpad-lazr.conf	1970-01-01 00:00:00 +0000
+++ configs/testrunner-appserver/launchpad-lazr.conf	2008-05-13 21:27:08 +0000
@@ -0,0 +1,6 @@
+# A schema's sections, keys, and values are automatically inherited,
+# except for '.optional' sections. Update this config to override key
+# values. Values are strings, except for numbers that look like ints.
+# The tokens true, false, and none are treated as True, False, and None.
+[meta]
+extends: ../development/launchpad-lazr.conf

=== added file 'configs/testrunner-appserver/launchpad.conf'
--- configs/testrunner-appserver/launchpad.conf	1970-01-01 00:00:00 +0000
+++ configs/testrunner-appserver/launchpad.conf	2008-05-13 21:27:08 +0000
@@ -0,0 +1,67 @@
+
+# Identify the component configuration used to define the site:
+site-definition site.zcml
+
+# Turn on Zope3 developer mode.
+devmode on
+
+# number of bytecode instructions to execute between checks for
+# interruptions (SIGINTR, thread switches):
+interrupt-check-interval 200
+
+<server>
+  type HTTP
+  address 8085
+</server>
+
+# For debugging purposes, you can use this publisher instead/as well
+# (obviously if it's as well, use a different port number). If there's
+# an exception, Zope will drop into pdb at the point of the exception.
+<server>
+  type PostmortemDebuggingHTTP
+  address 8089
+</server>
+
+<server>
+  type DebugLayerHTTP
+  address 8086
+</server>
+
+<server>
+  type PrivateXMLRPC
+  address 8087
+</server>
+
+# non-persistent in-memory storage
+<zodb>
+  <mappingstorage/>
+</zodb>
+
+<accesslog>
+  # This sets up logging to both a file (access.log) and to standard
+  # output (STDOUT).  The "path" setting can be a relative or absolute
+  # filesystem path or the tokens STDOUT or STDERR.
+
+  <logfile>
+    path launchpad-access.log
+  </logfile>
+
+  <logfile>
+    path STDOUT
+  </logfile>
+</accesslog>
+
+<eventlog>
+  # This sets up logging to both a file (z3.log) and to standard
+  # output (STDOUT).  The "path" setting can be a relative or absolute
+  # filesystem path or the tokens STDOUT or STDERR.
+
+  <logfile>
+    path launchpad.log
+  </logfile>
+
+  <logfile>
+    path STDOUT
+  </logfile>
+</eventlog>
+

=== added file 'configs/testrunner-appserver/test-process-lazr.conf'
--- configs/testrunner-appserver/test-process-lazr.conf	1970-01-01 00:00:00 +0000
+++ configs/testrunner-appserver/test-process-lazr.conf	2008-05-13 21:27:08 +0000
@@ -0,0 +1,8 @@
+# This is an empty conf file used strictly to verify that the process_name
+# controls the conf file that is loaded.
+
+[meta]
+extends: launchpad-lazr.conf
+
+[answertracker]
+days_before_expiration: 30

=== added file 'lib/canonical/launchpad/doc/launchpadlib.txt'
--- lib/canonical/launchpad/doc/launchpadlib.txt	1970-01-01 00:00:00 +0000
+++ lib/canonical/launchpad/doc/launchpadlib.txt	2008-05-13 21:27:08 +0000
@@ -0,0 +1,6 @@
+= launchpadlib =
+
+    >>> from urllib import urlopen
+    >>> connection = urlopen('http://launchpad.dev:8085')
+    >>> connection.read()[:9]
+    '<!DOCTYPE'

=== modified file 'lib/canonical/launchpad/ftests/test_system_documentation.py'
--- lib/canonical/launchpad/ftests/test_system_documentation.py	2008-05-06 15:40:54 +0000
+++ lib/canonical/launchpad/ftests/test_system_documentation.py	2008-05-13 21:27:08 +0000
@@ -29,8 +29,8 @@
 from canonical.launchpad.webapp.authorization import LaunchpadSecurityPolicy
 from canonical.launchpad.webapp.tests import test_notifications
 from canonical.testing import (
-    LaunchpadZopelessLayer, LaunchpadFunctionalLayer,DatabaseLayer,
-    FunctionalLayer)
+    AppServerLayer, DatabaseLayer, FunctionalLayer, LaunchpadFunctionalLayer,
+    LaunchpadZopelessLayer)
 
 
 here = os.path.dirname(os.path.realpath(__file__))
@@ -761,6 +761,11 @@
             layer=LaunchpadZopelessLayer,
             setUp=setUp, tearDown=tearDown,
             ),
+    'launchpadlib.txt': LayeredDocFileSuite(
+        '../doc/launchpadlib.txt',
+        layer=AppServerLayer,
+        setUp=setUp, tearDown=tearDown,
+        )
     }
 
 

=== modified file 'lib/canonical/testing/__init__.py'
--- lib/canonical/testing/__init__.py	2008-04-13 22:50:24 +0000
+++ lib/canonical/testing/__init__.py	2008-05-13 21:27:08 +0000
@@ -52,9 +52,7 @@
 
 
 # Imported here to avoid circular import issues
-from canonical.testing.layers import (
-    ExperimentalLaunchpadZopelessLayer,
-    BaseLayer, DatabaseLayer, LibrarianLayer, FunctionalLayer,
-    LaunchpadLayer, ZopelessLayer, LaunchpadFunctionalLayer,
-    LaunchpadZopelessLayer, PageTestLayer, TwistedLayer, LaunchpadScriptLayer,
-    TwistedLaunchpadZopelessLayer)
+# pylint: disable-msg=W0401
+from canonical.testing.layers import *
+from canonical.testing.layers import __all__ as layers_all
+__all__.extend(layers_all)

=== modified file 'lib/canonical/testing/layers.py'
--- lib/canonical/testing/layers.py	2008-04-25 13:54:13 +0000
+++ lib/canonical/testing/layers.py	2008-05-13 21:27:08 +0000
@@ -20,24 +20,36 @@
 """
 
 __metaclass__ = type
-
 __all__ = [
-    'BaseLayer', 'DatabaseLayer', 'LibrarianLayer', 'FunctionalLayer',
-    'LaunchpadLayer', 'ZopelessLayer', 'LaunchpadFunctionalLayer',
-    'LaunchpadZopelessLayer', 'LaunchpadScriptLayer', 'PageTestLayer',
-    'LayerConsistencyError', 'LayerIsolationError', 'TwistedLayer',
-    'ExperimentalLaunchpadZopelessLayer', 'TwistedLaunchpadZopelessLayer'
+    'AppServerLayer',
+    'BaseLayer',
+    'DatabaseLayer',
+    'ExperimentalLaunchpadZopelessLayer',
+    'FunctionalLayer',
+    'LaunchpadFunctionalLayer',
+    'LaunchpadLayer',
+    'LaunchpadScriptLayer',
+    'LaunchpadZopelessLayer',
+    'LayerIsolationError',
+    'LibrarianLayer',
+    'PageTestLayer',
+    'TwistedLaunchpadZopelessLayer',
+    'TwistedLayer',
+    'ZopelessLayer',
     ]
 
+import datetime
+import errno
 import gc
 import logging
 import os
 import signal
 import socket
 import sys
-from textwrap import dedent
 import threading
 import time
+
+from textwrap import dedent
 from unittest import TestCase, TestResult
 from urllib import urlopen
 
@@ -58,16 +70,20 @@
 from canonical.launchpad.ftests import ANONYMOUS, login, logout, is_logged_in
 import canonical.launchpad.mail.stub
 from canonical.launchpad.mail.mailbox import TestMailBox
+from canonical.launchpad.mailman.runmailman import stop_mailman
 from canonical.launchpad.scripts import execute_zcml_for_scripts
+from canonical.launchpad.scripts.runlaunchpad import start_launchpad
 from canonical.launchpad.webapp.servers import (
     LaunchpadAccessLogger, register_launchpad_request_publication_factories)
 from canonical.lp import initZopeless
 from canonical.librarian.ftests.harness import LibrarianTestSetup
+from canonical.pidfile import get_pid, remove_pidfile
 from canonical.testing import reset_logging
 from canonical.testing.profiled import profiled
 
 
 orig__call__ = zope.app.testing.functional.HTTPCaller.__call__
+COMMA = ','
 
 
 class MockRootFolder:
@@ -117,6 +133,28 @@
         return True
 
 
+def wait_children(seconds=120):
+    """Wait for all children to exit.
+
+    :param seconds: Maximum number of seconds to wait.  If None, wait
+        forever.
+    """
+    now = datetime.datetime.now
+    if seconds is None:
+        until = None
+    else:
+        until = now() + datetime.timedelta(seconds=seconds)
+    while True:
+        try:
+            os.waitpid(-1, os.WNOHANG)
+        except OSError, error:
+            if error.errno != errno.ECHILD:
+                raise
+            break
+        if until is not None and now() > until:
+            break
+
+
 class BaseLayer:
     """Base layer.
 
@@ -139,10 +177,8 @@
     @profiled
     def setUp(cls):
         BaseLayer.isSetUp = True
-
         # Kill any Librarian left running from a previous test run.
         LibrarianTestSetup().tearDown()
-
         # Kill any database left lying around from a previous test run.
         try:
             DatabaseLayer.connect().close()
@@ -162,9 +198,7 @@
         # Store currently running threads so we can detect if a test
         # leaves new threads running.
         BaseLayer._threads = threading.enumerate()
-
         BaseLayer.check()
-
         BaseLayer.original_working_directory = os.getcwd()
 
         # Tests and test infrastruture sometimes needs to know the test
@@ -182,7 +216,6 @@
     @classmethod
     @profiled
     def testTearDown(cls):
-
         # Get our current working directory, handling the case where it no
         # longer exists (!).
         try:
@@ -199,24 +232,22 @@
             os.chdir(BaseLayer.original_working_directory)
 
         BaseLayer.original_working_directory = None
-
         reset_logging()
-
         del canonical.launchpad.mail.stub.test_emails[:]
-
         BaseLayer.test_name = None
-
         BaseLayer.check()
 
         # Check for tests that leave live threads around early.
         # A live thread may be the cause of other failures, such as
         # uncollectable garbage.
         new_threads = [
-                thread for thread in threading.enumerate()
-                    if thread not in BaseLayer._threads and thread.isAlive()]
+            thread for thread in threading.enumerate()
+            if thread not in BaseLayer._threads and thread.isAlive()
+            ]
+
         if new_threads:
             BaseLayer.flagTestIsolationFailure(
-                    "Test left new live threads: %s" % repr(new_threads))
+                "Test left new live threads: %s" % repr(new_threads))
         del BaseLayer._threads
 
         # Objects with __del__ methods cannot participate in refence cycles.
@@ -241,13 +272,13 @@
         """
         if FunctionalLayer.isSetUp and ZopelessLayer.isSetUp:
             raise LayerInvariantError(
-                "Both Zopefull and Zopeless CA environments setup"
-                )
+                "Both Zopefull and Zopeless CA environments setup")
 
         # Detect a test that causes the component architecture to be loaded.
         # This breaks test isolation, as it cannot be torn down.
-        if (is_ca_available() and not FunctionalLayer.isSetUp
-                and not ZopelessLayer.isSetUp):
+        if (is_ca_available()
+            and not FunctionalLayer.isSetUp
+            and not ZopelessLayer.isSetUp):
             raise LayerIsolationError(
                 "Component architecture should not be loaded by tests. "
                 "This should only be loaded by the Layer."
@@ -258,8 +289,7 @@
         # but it is better for the tear down to be explicit.
         if ZopelessTransactionManager._installed is not None:
             raise LayerIsolationError(
-                    "Zopeless environment was setup and not torn down."
-                    )
+                "Zopeless environment was setup and not torn down.")
 
         # Detect a test that forgot to reset the default socket timeout.
         # This safety belt is cheap and protects us from very nasty
@@ -1063,3 +1093,70 @@
 
 class TwistedLaunchpadZopelessLayer(TwistedLayer, LaunchpadZopelessLayer):
     """A layer for cleaning up the Twisted thread pool."""
+
+
+class AppServerLayer(LaunchpadZopelessLayer):
+    """Environment for starting and stopping the app server."""
+
+    services = ('librarian', 'restricted-librarian')
+    LPCONFIG = 'testrunner-appserver'
+
+    @classmethod
+    @profiled
+    def setUp(cls):
+        pid = os.fork()
+        if pid == 0:
+            # The child.
+            os.execlp('make', 'make', '-i' '-s', 'LPCONFIG=%s' % cls.LPCONFIG,
+                      'run_all_quickly_and_quietly')
+            # Should never get here...
+            os._exit()
+        # The parent.  Wait until the app server is responsive, but not
+        # forever.
+        until = time.time() + 60
+        while time.time() < until:
+            try:
+                # XXX Load the proper config file to find the server address
+                # for pinging.
+                connection = urlopen('http://launchpad.dev:8085')
+                connection.read()
+            except IOError, (error_message, error):
+                if error.args[0] != errno.ECONNREFUSED:
+                    raise
+                time.sleep(0.5)
+            else:
+                connection.close()
+                break
+        else:
+            cls.stopAllServices()
+
+    @classmethod
+    @profiled
+    def tearDown(cls):
+        cls.stopAllServices()
+        # Ensure that there are no child processes still running.
+        try:
+            os.waitpid(-1, os.WNOHANG)
+        except OSError, error:
+            if error.errno != errno.ECHILD:
+                raise
+        else:
+            cls.stopAllServices()
+            raise LayerIsolationError('Child processes have leaked through.')
+
+    @classmethod
+    @profiled
+    def testSetUp(cls):
+        pass
+
+    @classmethod
+    @profiled
+    def testTearDown(cls):
+        pass
+
+    @classmethod
+    @profiled
+    def stopAllServices(cls):
+        os.system('make -i -s LPCONFIG=%s stop_quickly_and_quietly'
+                  % cls.LPCONFIG)
+        wait_children()

=== modified file 'utilities/killservice.py'
--- utilities/killservice.py	2008-03-15 18:21:53 +0000
+++ utilities/killservice.py	2008-05-13 21:27:08 +0000
@@ -12,7 +12,7 @@
 from signal import SIGTERM
 from optparse import OptionParser
 from canonical.config import config
-from canonical.pidfile import pidfile_path
+from canonical.pidfile import get_pid, pidfile_path, remove_pidfile
 from canonical.launchpad.scripts import logger_options, logger
 from canonical.launchpad.mailman.runmailman import stop_mailman
 
@@ -29,25 +29,22 @@
         if service == 'mailman' and config.mailman.launch:
             stop_mailman()
             continue
-        pidfile = pidfile_path(service)
-        log.debug("PID file is %s", pidfile)
-        if os.path.exists(pidfile):
-            pid = open(pidfile).read()
-            try:
-                pid = int(pid)
-            except ValueError:
-                log.error("Badly formatted PID in %s (%r)", pidfile, pid)
-            else:
-                log.info("Killing %s (%d)", service, pid)
-                try:
-                    os.kill(pid, SIGTERM)
-                except OSError, x:
-                    log.error("Unable to kill %s (%d) - %s",
-                            service, pid, x.strerror)
-                try:
-                    os.unlink(pidfile)
-                except OSError:
-                    pass
+        log.debug("PID file is %s", pidfile_path(service))
+        try:
+            pid = get_pid(service)
+        except ValueError, error:
+            log.error(error)
+            continue
+        if pid is not None:
+            log.info("Killing %s (%d)", service, pid)
+            try:
+                os.kill(pid, SIGTERM)
+            except OSError, x:
+                log.error("Unable to kill %s (%d) - %s",
+                          service, pid, x.strerror)
+            try:
+                remove_pidfile(service)
+            except OSError:
+                pass
         else:
             log.debug("No PID file for %s", service)
-

